

typedef struct {
        int position;
        unsigned int speed;
        unsigned char direction;
        unsigned char state;
} PwmMotor;

PwmMotor Motor[4];



void motor_set(unsigned char num, unsigned int value) {
	unsigned int n;
	if (num == 0) {
		if (OCR1A * -1 + 255 < value) {
			for (n = OCR1A * -1 + 255; n < value; n++) {
				PWM_Set_1a(n);
				delay_ms(10);
			}
		}
		PWM_Set_1a(value);
		Motor[num].speed = value;
	} else if (num == 1) {
		if (OCR1B * -1 + 255 < value) {
			for (n = OCR1B * -1 + 255; n < value; n++) {
				PWM_Set_1b(n);
				delay_ms(10);
			}
		}
		PWM_Set_1b(value);
		Motor[num].speed = value;
	} else if (num == 2) {
		if (value == 0) {
			PORTD &= ~(1<<PD6);
			Motor[num].speed = 0;
		} else {
			for (n = 0; n < 1000; n++) {
				PORTD |= (1<<PD6);
				delay_ms(1);
				PORTD &= ~(1<<PD6);
				delay_ms(2);
			}
			for (n = 0; n < 1000; n++) {
				PORTD |= (1<<PD6);
				delay_ms(1);
				PORTD &= ~(1<<PD6);
				delay_ms(1);
			}
			for (n = 0; n < 1000; n++) {
				PORTD |= (1<<PD6);
				delay_ms(2);
				PORTD &= ~(1<<PD6);
				delay_ms(1);
			}
			PORTD |= (1<<PD6);
			Motor[num].speed = 1;
		}
	} else if (num == 3) {
		if (value == 0) {
			PORTD &= ~(1<<PD7);
			Motor[num].speed = 0;
		} else {
			for (n = 0; n < 1000; n++) {
				PORTD |= (1<<PD7);
				delay_ms(1);
				PORTD &= ~(1<<PD7);
				delay_ms(2);
			}
			for (n = 0; n < 1000; n++) {
				PORTD |= (1<<PD7);
				delay_ms(1);
				PORTD &= ~(1<<PD7);
				delay_ms(1);
			}
			for (n = 0; n < 1000; n++) {
				PORTD |= (1<<PD7);
				delay_ms(2);
				PORTD &= ~(1<<PD7);
				delay_ms(1);
			}
			PORTD |= (1<<PD7);
			Motor[num].speed = 1;
		}
	}
}

void motor_init(void) {
// 	Motor 1 (PWM)
	DDRD |= (1<<PD5);
	PORTD &= ~(1<<PD5);
// 	Motor 2 (PWM)
	DDRE |= (1<<PE2);
	PORTE &= ~(1<<PE2);
// 	Motor 3 (On/Off)
	DDRD |= (1<<PD6);
	PORTD &= ~(1<<PD6);
// 	Motor 4 (On/Off)
	DDRD |= (1<<PD7);
	PORTD &= ~(1<<PD7);

	PWM_Init();
	PWM_Set_1a(0);
	PWM_Set_1b(0);
}

